# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.23.1-42.fc8}

%define kmod_name em8300
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%ifarch i686
%define pae PAE
%endif
%ifarch ppc sparc64
%define smp smp
%endif
%ifarch ppc64
%define kdump kdump
%endif
%{!?kvariants: %define kvariants "" %{?pae} %{?smp} %{?kdump}}

%define prever  %{nil}

Name:           %{kmod_name}-kmod
Summary:        Kernel modules for DXR3/Hollywood Plus MPEG decoder cards
Version:        0.16.3
Release:        6.%(echo %{kverrel} | tr - _)

Group:          System Environment/Kernel
License:        GPLv2+
URL:            http://dxr3.sourceforge.net/
Source0:        http://downloads.sourceforge.net/dxr3/%{kmod_name}-nofirmware-%{version}.tar.gz
Patch0:         http://cachalot.mine.nu/src/dxr3/em8300-adv7170-wss.patch
Patch1:         %{name}-0.16.3-2623.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExcludeArch:    i386 i586

%description
%{summary}.

%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c
cd %{kmod_name}-%{version}%{?prever}
%patch0 -p0
%patch1 -p0
cd ..
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-%{version}%{?prever} _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants} ; do
    kv=%{kverrel}$kvariant
    ks=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    make %{?_smp_mflags} -C _kmod_build_$kvariant/modules \
        V=1 KERNVER=$kv KERNEL_LOCATION=$ks
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants} ; do
    kv=%{kverrel}$kvariant
    ks=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    make -C _kmod_build_$kvariant/modules install DESTDIR=$RPM_BUILD_ROOT \
        KERNVER=$kv KERNEL_LOCATION=$ks INSTALL_MOD_DIR=extra/%{kmod_name} \
        DEPMOD=/bin/true V=1
done
chmod +x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*.ko


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed Oct 31 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.3-6
- Don't run depmod during build even if System.map is available.
- Run "make install" in verbose mode.
- Build for kernel 2.6.23.1-42.fc8.

* Thu Oct 18 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23.1-23.fc8.

* Sat Oct  6 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23-0.220.rc9.git2.fc8.

* Tue Sep 25 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23-0.202.rc8.fc8.

* Wed Sep 19 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23-0.187.rc6.git7.fc8.

* Tue Sep 18 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23-0.186.rc6.git7.fc8.

* Wed Aug 22 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.3-5
- 0.16.3, build for kernel 2.6.23-0.124.rc3.git2.fc8.
- Fix build with recent 2.6.23 rc kernels.
- Use ExcludeArch instead of ExclusiveArch.
- License: GPLv2+

* Wed Jul 25 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.23-0.45.rc0.git16.fc8.

* Sat Jul 21 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.3-0.6.rc2
- Restore ExclusiveArch, build for kernel 2.6.23-0.41.rc0.git14.fc8.

* Sat Jul 21 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.3-0.5.rc2
- 0.16.3-rc2.
- Test build without ExclusiveArch for kernel 2.6.23-0.35.rc0.git6.fc8.

* Wed Jul 11 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.3-0.1.rc1
- 0.16.3-rc1, build for kernel 2.6.22-8.fc8.
- Bring up to date with current Rawhide kernel archs and variants.

* Sat May 12 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.21-1.3149.fc7.

* Mon May  7 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.2-5
- 0.16.2, build for kernel 2.6.21-1.3141.fc7.

* Thu Apr 26 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.2-0.1.rc2
- 0.16.2-rc2, build for kernel 2.6.20-1.3104.fc7.

* Fri Apr 20 2007 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.20-1.3094.fc7.

* Wed Apr  4 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.2-0.1.rc1
- 0.16.2-rc1, build for kernel 2.6.20-1.3040.fc7.
- Update kmodtool to 0.10.13.

* Mon Mar 19 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-7
- Drop OSS default patch, making ALSA the default now; users who need
  OSS should use the audio_driver=oss option of the em8300 module.
- Use upstream 2.6.21/ALSA patch.
- Build for kernel 2.6.20-1.2997.fc7, including ppc64.

* Sun Mar  4 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-6
- Re-enable i586 and i686.
- Build for kernel 2.6.20-1.2962.fc7.

* Thu Mar  1 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-5
- 0.16.1, build for kernel 2.6.20-1.2953.fc7.
- Exclude i*86 until #229489 is fixed.

* Sat Feb 24 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.1-0.5.rc2
- 0.16.1-rc2 + patch for post-2.6.20 ALSA changes.
- Update kmodtool to 0.10.12.
- Build for kernel 2.6.20-1.2942.fc7.

* Tue Feb  6 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-10
- Adjust to current Rawhide arch-variant combos (kdump, xen, debug).

* Tue Feb  6 2007 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-6
- Patch for kernel 2.6.20 (David van Vyfeyken), build for 2.6.20-1.2922.fc7.

* Mon Dec 18 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-5
- 0.16.0, build for kernel 2.6.18-1.2868.fc6.

* Sun Nov 12 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.4.rc2
- Let rpmbuild strip modules.

* Sun Nov 12 2006 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.18-1.2849.fc6.

* Sat Nov 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.3.rc2
- 0.16.0-rc2.

* Tue Oct 17 2006 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.18-1.2798.fc6.

* Sun Oct  8 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.3.rc1
- Don't use <linux/config.h>.
- Build for kernel 2.6.18-1.2747.fc6.

* Wed Oct  4 2006 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.18-1.2726.fc6.

* Sat Sep 23 2006 Ville Skyttä <ville.skytta at iki.fi>
- Rebuild for kernel 2.6.18-1.2689.fc6.

* Sat Sep 16 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.2.rc1
- Fix install location when built against 2.6.18-rc*.

* Fri Sep 15 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.16.0-0.1.rc1
- 0.16.0-rc1, kernel 2.6.17 patch applied upstream.
- Patch to default to OSS for backwards compatibility.
- Adjust to FC6 kernel variants, build for 2.6.17-1.2647.fc6.
- Update kmodtool to 0.10.11.
- Drop early FC5 hacks.

* Tue Jul 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-6
- Enable PPC SMP builds (#189400).
- Use firmwareless tarball (#189400).
- Untabify specfile (#189400).

* Mon Jun 26 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-5
- Apply upstream patch to fix build with kernel 2.6.17, rediff WSS patch.

* Sun Jun 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-4
- Invoke kmodtool with bash instead of sh.

* Sun May 14 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-3
- Require version >= of em8300-kmod-common.
- Provide em8300-kmod instead of kmod-em8300 to fix upgrade woes (#970).

* Thu Apr 27 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-2
- Provide "kernel-modules" instead of "kernel-module" to match yum's config.

* Mon Apr 10 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-1
- 0.15.3.

* Sun Mar 26 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.3-0.1.rc1
- 0.15.3-rc1.

* Sat Mar 25 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-6.cvs20060325
- CVS snapshot from today, I2C patches no longer needed, should fix #839.
- Allow passing --define kversion and --define kvariants to the build again.
- Update kmodtool to 0.10.6.

* Sat Mar 18 2006 <fedora[AT]leemhuis.info> - 0.15.2-5
- xenU does not build and was probably a bad idea idea in any case

* Sat Mar 18 2006 <fedora[AT]leemhuis.info> - 0.15.2-4
- drop 0.lvn
- hardcode kernel and variants
- add ExclusiveArch until we have something better

* Sun Jan 29 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.4
- Adapt to FE kernel module packaging conventions.
- Add upstream patch to fix build with 2.6.16-rc1+ kernels.

* Sat Jan 21 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.3
- Don't run autoreconf in modules-only builds (#736).

* Fri Jan 13 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.2
- Split GUI utilities into -utils subpackage, build them with GTK2.
- Drop no longer needed -fPIC tweak on x86_64.
- Fix Group tag of main package.

* Thu Nov 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.1
- 0.15.2.
- Make the actual microcode to load a symlink; additional local microcodes
  can now be installed in /lib/firmware, and /lib/firmware/em8300.bin
  symlinked to the one to actually use.

* Sat Nov 19 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.0.1.rc2
- 0.15.2-rc2, most desktop entry fixups applied upstream.
- Add icon for DXR3view menu entry.

* Sat Nov  5 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.2-0.lvn.0.1.rc1
- 0.15.2-rc1, includes microcode autoload capabilities.
- Include icon for dhc, remove invalid desktop entry categories.
- Update README-modprobe.conf.

* Tue Sep  6 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.1-0.lvn.1
- 0.15.1.

* Wed Aug 31 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.1-0.lvn.0.1.rc1
- 0.15.1-rc1, drop udev patch.

* Mon Jul 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.5
- Drop libdxr3, nothing uses it and it'll be removed in next upstream release.

* Fri Jul  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.4
- Install modules into extra/em8300.

* Sat Jun 18 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.3
- Use udev rules.d snippet for device permissions.

* Sun Jun 12 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.2
- Add "--with 2612" rpmbuild option to enable building with 2.6.12-pre
  kernels that report themselves as 2.6.11, such as early FC4 ones.

* Wed Jun  1 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.1
- 0.15.0.

* Sun May 29 2005 Thorsten Leemhuis <fedora at leemhuis.info> - 0.15.0-0.lvn.0.15.rc4
- Build userspace with -fPIC on x86_64 to fix build error

* Tue May 24 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.14.rc4
- 0.15.0rc4, memset patch applied upstream.

* Fri May 13 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.13.rc3
- Improve optional rpmbuild options:
  --without modules: do not build the kernel modules
  --without userland: do not build the userland stuff

* Fri Apr 29 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc3
- 0.15.0.rc3.

* Sun Apr 10 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.rc2
- 0.15.0.rc2.
- Drop unused Provides: kernel-module.
- Move video group creation from main to kernel module package(s).

* Sat Apr  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.12.cvs20050331
- Add FC4 kernel-devel and new kernel-module-devel compatibility.

* Thu Mar 31 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050331
- Update to upstream CVS HEAD as of now, many patches applied upstream.

* Sat Mar 26 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050326
- Update to upstream CVS HEAD as of now.
- Revert microcode location to upstream default (/usr/share/misc/em8300.uc).

* Tue Mar  8 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.11.cvs20050308
- Update to upstream CVS HEAD as of now.

* Sun Feb 27 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20050227
- Update tarball naming and modprobe.conf README, no upstream changes.

* Mon Feb  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.15.0-0.lvn.0.10.cvs20041117
- Use my pre-rolled/patched tarball.
- Remove unnecessary Epochs.

* Tue Jan 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.9.cvs20041117
- URLize patches and extra sources.

* Fri Jan  7 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.8.cvs20041117
- Remove "manual" device node creation, let udev handle all of it.
- Add console.perms README.

* Mon Dec  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.7.cvs20041117
- Apply ADV7170 WSS patch from Seppo Ingalsuo.
- Include upstream ALSA patch, but don't apply it just yet.
- Fix em8300setup usage message.
- Get rid of acconfig.h to appease newer autotools.
- Make "--with(out) kmod" conditional sections smaller in the specfile.

* Sun Dec  5 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.6.cvs20041117
- Create the video group in the correct place.

* Sun Nov 28 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.5.cvs20041117
- Adjust setup for udev.
- Create/use the video group.
- Avoid creating /usr/include/linux twice during build.

* Wed Nov 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041117
- Update to 20041117, most patches applied upstream.

* Wed Nov  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20041101
- Update to 20041101 + upstream patches.

* Sat Oct  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.4.cvs20040907
- Fix module directory permissions.

* Mon Sep 13 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.3.cvs20040907
- Install modules into /lib/modules/$uname/updates/em8300.
- Add URL to tarball.

* Sat Sep 11 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.2.cvs20040907
- Reset mode of installed modules to 644.

* Tue Sep  7 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040907
- Update to 0.15.0.cvs20040907.
- Disable dependency tracking to speed up the build.

* Sun Aug 29 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040827
- Update to 0.15.0.cvs20040827.

* Fri Jul 30 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.lvn.0.1.cvs20040730
- Reorganize packaging, introduce libdxr3* as real subpackages.
- Add "--without kmod" rpmbuild option for skipping the kernel module build
  and "--with kmod" for building only the kernel modules.
- s/fdr/lvn/ due to non open source microcode.

* Sat Jul  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.15.0-0.fdr.0.1.cvs20040702
- Update to 0.15.0.cvs20040702.

* Wed Mar 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.14.0-0.fdr.1
- Update to 0.14.0.

* Fri Feb 20 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040220
- Update to CVS 20040220.

* Mon Feb  9 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.3.cvs20040107
- Update to kmodhelper 0.9.8.

* Sat Jan 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.2.cvs20040107
- Drop release from the dependency between the kernel module and main package.
- Update kmodhelper to 0.9.7.
- Use MAKEDEV for creating the device nodes.
- Spec file cleanups.

* Tue Jan  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.13.0-0.fdr.1.cvs20040107
- First build.
